#define _GNU_SOURCE
#include <dlfcn.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>

// Quick wrapper for older kernels
int
pipe2(int pipefd[2], int flags)
{
    static int try_pipe2 = 1;
    static int (*next)(int pipefd[2], int flags) = NULL;

    if (try_pipe2) {
        if (!next)
            next = dlsym(RTLD_NEXT, "pipe2");
        int res = next(pipefd, flags);
        if (res == 0 || errno != ENOSYS)
            return res;
        try_pipe2 = 0;
    }

    if (flags & ~O_CLOEXEC) {
        errno = EINVAL;
        return -1;
    }

    int res = pipe(pipefd);
    if (res == 0 && flags & O_CLOEXEC) {
        ioctl(pipefd[0], FIOCLEX);
        ioctl(pipefd[1], FIOCLEX);
    }
    return res;
}
